import Vue from "vue";
import VueRouter from "vue-router";
import Home from "../views/Home.vue";
import UploadNew from "../views/UploadNew.vue"
import ImagePost from "../views/ImagePost.vue";

Vue.use(VueRouter);

const routes = [
  {
    path: "/",
    name: "Home",
    component: Home,
  },
  {
    path: "/upload",
    name: "UploadNew",
    component: UploadNew,
  },
  {
    path: "/:page",
    name: "Page",
    component: Home,
  },
  {
    path: "/image/:flake",
    name: "ImagePost",
    component: ImagePost,
  },
];

const router = new VueRouter({
  base: process.env.BASE_URL,
  routes,
});

export default router;
